#!/bin/sh
# Built on TCL v4.0.2
# Required extensions:
#	compiletc
#    bison
#    diffutils
#    file
#    findutils
#    flex
#    gawk
#    gcc
#     gcc_libs
#      binutils
#       mpfr
#        gmp
#        mpc
#    grep
#    m4
#    make
#    patch
#    pkg-config
#     glib2
#     popt
#    sed
#    e2fsprogs_base-dev
#    eglibc_base-dev
#    freetype_base-dev
#    gcc_base-dev
#    imlib2_base-dev
#    jpeg_base-dev
#    libpng_base-dev
#    linux-3.0.1_api_headers
#    util-linux_base-dev
#    zlib_base-dev
#	squashfs-tools-4.x
#	tar
#	perl5

getTime.sh

installExtension() {
	if [ ! -e /usr/local/tce.installed/$1 ]; then
		echo "Installing "$1" ..."
		
		if [ -e $TCEDIR/optional/$1.tcz ]; then
			tce-load -i $1
		else
			tce-load -wi $1
		fi
		
		[ ! -e /usr/local/tce.installed/$1 ] && echo "Error: Extension "$1" not installed! Aborting" && exit
	fi
}

createExtension() {
	mksquashfs $1 $1.tcz -noappend
	[ ! -e $1.tcz ] && echo "Error: "$1".tcz not created! Aborting" && exit
}

unpackSrc(){
	#unpack source
	if [ -e $1.tar.bz2 ]; then
		tar -jxf $1.tar.bz2
	elif [ -e $1.tb2 ]; then
		tar -jxf $1.tb2
	elif [ -e $1.tbz ]; then
		tar -jxf $1.tbz
	elif [ -e $1.tar.gz ]; then
		tar -zxf $1.tar.gz
	elif [ -e $1.tgz ]; then
		tar -zxf $1.tgz
	elif [ -e $1.tar.xz ]; then
		tar -Jxf $1.tar.xz
	elif [ -e $1.txz ]; then
		tar -Jxf $1.txz
	elif [ -e $1.tar.lzma ]; then
		tar -xf $1.tar.lzma --lzma
	elif [ -e $1.tlz ]; then
		tar -xf $1.tlz --lzma
	else
		echo "Source "$1" not found! Aborting" && exit
	fi
}

# Install these extensions automagically
export EXTS="compiletc
squashfs-tools-4.x
tar
perl5"

export TCEDIR=`cat /opt/.tce_dir`
export CFLAGS="-march=i486 -mtune=i686 -O3 -pipe"
export CXXFLAGS=$CFLAGS" -fno-exceptions -fno-rtti"
export PKG_CONFIG_PATH=/usr/local/lib/pkgconfig:/usr/lib/pkgconfig
export EXTNAME="ccache"
export VER="-3.1.6"
export DESTDIR=`pwd`/$EXTNAME
export PKGNAME=$EXTNAME$VER

for f in $EXTS; do
	installExtension $f
done

unpackSrc($PKGNAME)

cd $PKGNAME

./configure && make && make check 2>&1 | tee ../$EXTNAME.test && make install || exit

cd $DESTDIR

rm -rf usr/local/share

sudo strip --strip-unneeded usr/local/bin/*

cd ..

createExtension $EXTNAME

rm -rf $EXTNAME $PKGNAME

# Create extension support files and test
installExtension "submitqc4"

submitqc4
